VERSION 5.00
Begin VB.Form frmActive 
   BorderStyle     =   0  'None
   Caption         =   "Form1"
   ClientHeight    =   10380
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   12315
   LinkTopic       =   "Form1"
   ScaleHeight     =   10380
   ScaleWidth      =   12315
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   WindowState     =   2  'Maximized
   Begin VB.Timer Timer1 
      Interval        =   1
      Left            =   1080
      Top             =   7800
   End
   Begin VB.CommandButton btnExit 
      Caption         =   "Exit"
      Height          =   375
      Left            =   120
      TabIndex        =   7
      Top             =   120
      Visible         =   0   'False
      Width           =   495
   End
   Begin VB.CommandButton btnSubmit 
      Caption         =   "Submit"
      Height          =   495
      Left            =   2760
      TabIndex        =   6
      Top             =   9240
      Visible         =   0   'False
      Width           =   1575
   End
   Begin VB.CommandButton btnBound 
      Caption         =   "Set Boundary"
      Height          =   495
      Left            =   2760
      TabIndex        =   5
      Top             =   7920
      Visible         =   0   'False
      Width           =   1575
   End
   Begin VB.PictureBox pct 
      AutoSize        =   -1  'True
      Height          =   6825
      Left            =   840
      ScaleHeight     =   6765
      ScaleWidth      =   9000
      TabIndex        =   3
      Top             =   360
      Width           =   9060
   End
   Begin VB.CommandButton btnContinue 
      Caption         =   "Continue"
      Height          =   495
      Left            =   4440
      TabIndex        =   2
      Top             =   9240
      Visible         =   0   'False
      Width           =   1575
   End
   Begin VB.CommandButton btnQuery 
      Caption         =   "Hatch!"
      Height          =   495
      Left            =   4440
      TabIndex        =   0
      Top             =   7920
      Width           =   1575
   End
   Begin VB.Image shpRed 
      Height          =   615
      Left            =   5280
      Picture         =   "Active.frx":0000
      Top             =   8520
      Visible         =   0   'False
      Width           =   735
   End
   Begin VB.Image shpGreen 
      Height          =   615
      Left            =   4440
      Picture         =   "Active.frx":00E6
      Top             =   8520
      Visible         =   0   'False
      Width           =   735
   End
   Begin VB.Label lblTries 
      Height          =   375
      Left            =   4320
      TabIndex        =   4
      Top             =   7320
      Width           =   1815
   End
   Begin VB.Label Label1 
      Caption         =   "0"
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   1200
      Visible         =   0   'False
      Width           =   615
   End
End
Attribute VB_Name = "frmActive"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim picPath, epsilon As Single 'picpath used for displaying purposes
Dim nMaxblock, iBlock As Integer 'iBlock = current block
Dim time As Long 'keep track of time
Dim Nq, iNq As Integer 'inQ = current query in a block
Dim xStar As Single
Dim bound(999) As Single
Dim delta As Single
Dim prefix, picNum, suffix As String
Dim scrollAllow, choseBound As Boolean

Private Sub Form_Load()

'enable wheel
Call WheelHook(Me.hWnd)

'center the image
pct.Left = (Screen.Width - pct.Width) / 2
'locate the button
btnQuery.Left = (Screen.Width - btnQuery.Width) / 2
btnContinue.Left = (Screen.Width - btnContinue.Width) / 2
btnBound.Left = btnQuery.Left
btnSubmit.Left = btnContinue.Left
'locate the shapes
shpGreen.Left = btnQuery.Left
shpRed.Left = shpGreen.Left + shpGreen.Width
'center response label
lblTries.Left = (Screen.Width - lblTries.Width) / 2

'initialize variables
initialize Nmaxblock1, delta1, xStar1, epsilon1, Nq1, log1

End Sub

Private Sub Form_Unload(Cancel As Integer)

Timer1.Enabled = False

Call WheelUnHook(Me.hWnd)
Close #1
Unload frmActive

End Sub

Private Sub btnBound_Click()

bound(iBlock) = picPath

btnSubmit.Visible = True
btnSubmit.Enabled = True
choseBound = True

'show both circles at the chosen place
shpGreen.Visible = True
shpRed.Visible = True

'write to log files
Print #1, "boundary " & FormatNumber(bound(iBlock), 2) & " " & time

End Sub

Private Sub btnContinue_Click()

'make responses invisible
btnContinue.Visible = False
shpRed.Visible = False
shpGreen.Visible = False

scrollAllow = True

'enable query button OR
'end queries if all queries are used up
If iNq = 0 Then 'no more queries
btnQuery.Visible = False
btnBound.Visible = True

'reset image at x=0
picPath = 0
pct.Picture = LoadPicture(App.path & prefix & "0.00" & suffix)

Else
btnQuery.Enabled = True
End If

End Sub

Private Sub btnQuery_Click()
Dim res As Boolean
Dim color As String
Dim xcolor As Integer

'compute query from probability
res = Compute_Query(epsilon, picPath, xStar)

'display corresponding shape
If res = True Then
shpGreen.Visible = True
color = "green"
Else
shpRed.Visible = True
color = "red"
End If

'disable query button, enable continue button
btnQuery.Enabled = False
btnContinue.Visible = True

'update counter
iNq = iNq - 1

'update how many tries left
'numLeft = numLeft - 1
'lblTries = "You have " & numLeft & " queries left"

'disable scrolling
scrollAllow = False

'record to log file
If color = "green" Then
xcolor = 0
Else
xcolor = 1
End If

Print #1, "query " & FormatNumber(picPath, 2) & " " & xcolor & " " & time

End Sub

Private Sub btnSubmit_Click()
Dim endnow As Boolean
Dim a, b As Single

'update # of blocks
iBlock = iBlock + 1

Print #1, "submit"

'if last block or condition satifies to end
endnow = False
If iBlock >= 3 Then
a = Max(bound(iBlock - 1), bound(iBlock - 2), bound(iBlock - 3))
b = Min(bound(iBlock - 1), bound(iBlock - 2), bound(iBlock - 3))
    If (a - b < delta) Then
    endnow = True
    End If
End If

If (endnow Or iBlock = nMaxblock) Then
    'display score
    
    Print #1, "end"
    
    Unload Me
    Exit Sub
Else
    iNq = Nq 'reset # queries in the block
End If

'reset image at x=0
picPath = 0
pct.Picture = LoadPicture(App.path & prefix & "0.00" & suffix)

btnBound.Visible = False
shpGreen.Visible = False
shpRed.Visible = False
btnSubmit.Visible = False
btnQuery.Visible = True
btnQuery.Enabled = True
choseBound = False

End Sub

Private Sub btnExit_Click()
Unload Me
End Sub

Private Function initialize(ByVal aNmaxblock As Integer, ByVal aDelta As Single, _
    ByVal aXStar As Single, ByVal aEpsilon As Single, ByVal aNq As Integer, _
    ByVal log As String)
    
'variables
nMaxblock = aNmaxblock
delta = aDelta
xStar = aXStar
Nq = aNq
epsilon = aEpsilon

'set counters
iNq = Nq
iBlock = 0

'set booleans
scrollAllow = True
choseBound = False

'load picture
picPath = 0
prefix = "\images\w_"
suffix = ".jpg"
picNum = FormatNumber(picPath, 2)

pct.Picture = LoadPicture(App.path & prefix & picNum & suffix)

'start timer
time = 0
Timer1.Enabled = True

'start recording the log file
id = id + 1
Open App.path & log For Output As #1
Print #1, "start"
Print #1, "x " & xStar
Print #1, "epsilon " & epsilon
Print #1, "Nq " & Nq
Print #1, "Nmaxblock " & nMaxblock
Print #1, "delta " & delta

End Function

Public Sub MouseWheel(ByVal MouseKeys As Long, ByVal Rotation As Long, ByVal Xpos As Long, ByVal Ypos As Long)
Dim bOver As Boolean

On Error Resume Next
bOver = (pct.Visible And IsOver(pct.hWnd, Xpos, Ypos))
On Error GoTo 0

'Me.Caption = picPath

If bOver And scrollAllow Then

    picPath = MScroll(Rotation, picPath)
    picNum = FormatNumber(picPath, 2)
    
    'Label1.Caption = picNum
    
    Print #1, "scroll " & picNum & " " & time
    pct.Picture = LoadPicture(App.path & prefix & picNum & suffix)
    
End If

'if a boundary has chosen
If choseBound Then
    'show the corresponding circle
    If Abs(picPath - bound(iBlock)) < 0.001 Then
    shpRed.Visible = True
    shpGreen.Visible = True
    btnSubmit.Enabled = True
    ElseIf picPath < bound(iBlock) Then
    shpRed.Visible = False
    shpGreen.Visible = True
    btnSubmit.Enabled = False
    ElseIf picPath > bound(iBlock) Then
    shpGreen.Visible = False
    shpRed.Visible = True
    btnSubmit.Enabled = False
    End If
End If

End Sub

Private Sub Timer1_Timer()
time = time + 1
End Sub
