Attribute VB_Name = "functions"
Option Explicit
Global type1 As String
Global Nmaxblock1 As Integer
Global delta1 As Single
Global xStar1 As Single
Global epsilon1 As Single
Global Nq1 As Integer
Global log1 As String
Global movie1 As String
Global id As Integer

'initializes a trial for a subject
Public Function initTrial(aType As String, movie As String, nMaxblock As Integer, _
    delta As Single, xStar As Single, epsilon As Single, Nq As Integer, log As String)

type1 = aType
log1 = log
movie1 = movie
Nmaxblock1 = nMaxblock
delta1 = delta
xStar1 = xStar
epsilon1 = epsilon
Nq1 = Nq

'Dim b As Integer
'b = 0

If StrComp("Active", type1) = 0 Then
    'call activeblock
    Load frmActive
    frmActive.Show vbModal
Else
    'Load frmPassive
    Load frmPassive
    frmPassive.Show vbModal
End If

End Function

Public Function Compute_Query(ByVal pr As Single, ByVal x As Single, ByVal pBound As Single) As Boolean

If x <= pBound Then
pr = 1 - pr 'probability of being green
End If

Randomize

'return true if green, false if red
'p = prob being green
Compute_Query = (Rnd <= pr)

End Function

'param Rotation = mouse wheel rotation
'param picPath = current position
'param factor = factor multiplier for mouse
'return = new value for picPath
Public Function MScroll(ByVal Rotation As Long, ByVal picPath As Single, _
    Optional ByVal factor As Integer = 10) As Single

If Rotation > 0 And picPath < 7.99 Then '7.99 b/c of floating error
'different rotation effects
    Select Case Rotation
        Case Is < 15 * factor
            MScroll = Min(picPath + 0.05, 8)
        Case Is < 30 * factor
            MScroll = Min(picPath + 0.1, 8)
        Case Is < 50 * factor
            MScroll = Min(picPath + 0.25, 8)
        Case Is < 80 * factor
            MScroll = Min(picPath + 0.5, 8)
        Case Else
            MScroll = Min(picPath + 0.75, 8)
    End Select
ElseIf Rotation < 0 And picPath > -7.99 Then '-7.99 b/c of floating error
'different rotation effects
    Select Case Rotation
        Case Is > -15 * factor
            MScroll = Max(picPath - 0.05, -8)
        Case Is > -30 * factor
            MScroll = Max(picPath - 0.1, -8)
        Case Is > -50 * factor
            MScroll = Max(picPath - 0.25, -8)
        Case Is > -80 * factor
            MScroll = Max(picPath - 0.5, -8)
        Case Else
            MScroll = Max(picPath - 0.75, -8)
    End Select
Else
    MScroll = picPath
End If

End Function

Public Function Min(value1 As Single, value2 As Single, Optional value3 As Single = -999) As Single

    If (value1 < value2) Then
        Min = value1
    Else
        Min = value2
    End If
    
    If ((Not value3 = -999) And value3 < Min) Then
        Min = value3
    End If

End Function

Public Function Max(value1 As Single, value2 As Single, Optional value3 As Single = -999) As Single
    If (value1 > value2) Then
        Max = value1
    Else
        Max = value2
    End If
    
    If ((Not value3 = -999) And value3 > Max) Then
        Max = value3
    End If
    
End Function
