function movie_maker(filename);

% function function movie_maker(filename);
%
% This function read a subject level file and creates the necessary movies
% for the machine and random yoked trials.

fid=fopen(filename,'r');

tmp=fscanf(fid,'%s/n');
while ~isempty(tmp);
    if strcmp(tmp,'Machine_Yoked')
        fscanf(fid,'%s/n');
        filename=fscanf(fid,'%s/n');%filename(1)=[];
        x=str2num(fscanf(fid,'%s/n'));
        epsilon=str2num(fscanf(fid,'%s/n'));
        Nq=str2num(fscanf(fid,'%s/n'));
        Nmaxblock=str2num(fscanf(fid,'%s/n'));
        delta=str2num(fscanf(fid,'%s/n'));
        if exist(filename)
            if strcmp(input(['THE FILE "' filename '"ALREADY EXISTS!!! Replace? (type yes or no): '],'s'),'yes');
                disp(['Creating Machine Yoked file: ' filename]);
                may(x,epsilon,Nq,Nmaxblock,delta,filename);
                %fileattrib(filename,'-w');
            else
                disp(['THE FILE "' filename '" WAS NOT RE-CREATED!!!']);
            end;
        else
            disp(['Creating Machine Yoked file: ' filename]);
            may(x,epsilon,Nq,Nmaxblock,delta,filename);
            %fileattrib(filename,'-w');
        end;

    end;
    if strcmp(tmp,'Random')
        fscanf(fid,'%s/n');
        filename=fscanf(fid,'%s/n');%filename(1)=[];
        x=str2num(fscanf(fid,'%s/n'));
        epsilon=str2num(fscanf(fid,'%s/n'));
        Nq=str2num(fscanf(fid,'%s/n'));
        Nmaxblock=str2num(fscanf(fid,'%s/n'));
        delta=str2num(fscanf(fid,'%s/n'));
        if exist(filename)
            if strcmp(input(['THE FILE "' filename '"ALREADY EXISTS!!! Replace? (type yes or no): '],'s'),'yes');
                disp(['Creating Machine Yoked file: ' filename]);
                ray(x,epsilon,Nq,Nmaxblock,delta,filename);
                %fileattrib(filename,'-w');
            else
                disp(['THE FILE "' filename '" WAS NOT RE-CREATED!!!']);
            end;
        else
            disp(['Creating Machine Yoked file: ' filename]);
            ray(x,epsilon,Nq,Nmaxblock,delta,filename);
            %fileattrib(filename,'-w');
        end;
    end;
    tmp=fscanf(fid,'%s/n');
end;

fclose(fid);
return;
